Scala Compiler2.12.13 < Back
 

# Packages

-  package root

  The Scala compiler and reflection APIs.

  The Scala compiler and reflection APIs.

  Definition Classes
    root
-  package scala
  Definition Classes
    root
-  package tools
  Definition Classes
    scala
-  package nsc
  Definition Classes
    tools
-  package ast
  Definition Classes
    nsc
-  package parser
  Definition Classes
    ast
-  trait Scanners extends ScannersCommon
  Definition Classes
    parser
- CommonTokenData
- DocScanner
- MalformedInput
- ParensAnalyzer
- Scanner
- ScannerCommon
- ScannerData
- SourceFileScanner
- TokenData
- UnitScanner

c

scala.tools.nsc.ast.parser.Scanners

# ParensAnalyzer 

###

#### class ParensAnalyzer extends UnitScanner

Source
  Scanners.scala

Linear Supertypes
UnitScanner, SourceFileScanner, Scanner, Scanners.DocScanner, Scanners.ScannerCommon, ScannerData, TokenData, Scanners.CommonTokenData, CharArrayReader, CharArrayReaderData, AnyRef, Any
 
Ordering

1. Alphabetic
2. By Inheritance

Inherited

1. ParensAnalyzer
2. UnitScanner
3. SourceFileScanner
4. Scanner
5. DocScanner
6. ScannerCommon
7. ScannerData
8. TokenData
9. CommonTokenData
10. CharArrayReader
11. CharArrayReaderData
12. AnyRef
13. Any

Implicitly

1. by any2stringadd
2. by StringFormat
3. by Ensuring
4. by ArrowAssoc

1. Hide All
2. Show All

Visibility

1. Public
2. All

### Instance Constructors

1.  new ParensAnalyzer(unit: Global.CompilationUnit, patches: List[BracePatch])

### Type Members

1.  class CharArrayLookaheadReader extends CharArrayReader
   Definition Classes
     CharArrayReader

### Value Members

1.  final def !=(arg0: Any): Boolean
   Definition Classes
     AnyRef → Any
2.  final def ##(): Int
   Definition Classes
     AnyRef → Any
3.  def +(other: String): String
   Implicit
     This member is added by an implicit conversion from ParensAnalyzer to any2stringadd[ParensAnalyzer] performed by method any2stringadd in scala.Predef.
   Definition Classes
     any2stringadd
4.  def ->[B](y: B): (ParensAnalyzer, B)
   Implicit
     This member is added by an implicit conversion from ParensAnalyzer to ArrowAssoc[ParensAnalyzer] performed by method ArrowAssoc in scala.Predef.
   Definition Classes
     ArrowAssoc
   Annotations
     @inline()
5.  final def ==(arg0: Any): Boolean
   Definition Classes
     AnyRef → Any
6.  def applyBracePatch(): Boolean

   Insert or delete a brace, if a patch exists for this offset

   Insert or delete a brace, if a patch exists for this offset

   Definition Classes
     UnitScanner → Scanner
7.  final def asInstanceOf[T0]: T0
   Definition Classes
     Any
8.  val balance: Map[Int, Int]
9.  val base: Int

   the base of a number

   the base of a number

   Definition Classes
     TokenData
10.  def beginDocComment(prefix: String): Unit
    Attributes
      protected
    Definition Classes
      DocScanner
11.  val bracePairs: List[BracePair]

    The list of matching top-level brace pairs (each of which may contain nested brace pairs).

12.  val buf: Array[Char]
    Definition Classes
      SourceFileScanner → CharArrayReader
13.  val cbuf: java.lang.StringBuilder

    A character buffer for literals

    A character buffer for literals

    Definition Classes
      Scanner
14.  val ch: Char

    the last read character

    the last read character

    Definition Classes
      CharArrayReaderData
15.  def charLitOr(op: () ⇒ Unit): Unit

    Parse character literal if current character is followed by \', or follow with given op and return a symbol literal token

    Parse character literal if current character is followed by \', or follow with given op and return a symbol literal token

    Definition Classes
      Scanner
16.  val charOffset: Int

    The offset one past the last read character

    The offset one past the last read character

    Definition Classes
      CharArrayReaderData
17.  def charVal: Char

    Convert current strVal to char value

    Convert current strVal to char value

    Definition Classes
      Scanner
18.  def checkNoLetter(): Unit
    Definition Classes
      Scanner
19.  def clone(): AnyRef
    Attributes
      protected[lang]
    Definition Classes
      AnyRef
    Annotations
      @throws( ... ) @native()
20.  def column(offset: Scanners.Offset): Int
21.  def copyFrom(sd: ScannerData): ParensAnalyzer.this.type
    Definition Classes
      ScannerData
22.  def copyFrom(td: TokenData): ParensAnalyzer.this.type
    Definition Classes
      TokenData
23.  def copyFrom(cd: CharArrayReaderData): ParensAnalyzer.this.type
    Definition Classes
      CharArrayReaderData
24.  val decodeUni: Boolean
    Definition Classes
      SourceFileScanner → CharArrayReader
25.  def deleteRBrace(): List[BracePatch]
26.  def deprecationWarning(off: Scanners.Offset, msg: String, since: String): Unit
    Definition Classes
      UnitScanner → SourceFileScanner → ScannerCommon
27.  def deprecationWarning(msg: String, since: String): Unit
    Definition Classes
      Scanner
28.  def discardDocBuffer(): Unit

    To prevent doc comments attached to expressions from leaking out of scope onto the next documentable entity, they are discarded upon passing a right brace, bracket, or parenthesis.

    To prevent doc comments attached to expressions from leaking out of scope onto the next documentable entity, they are discarded upon passing a right brace, bracket, or parenthesis.

    Definition Classes
      DocScanner
29.  def doubleVal: Double
    Definition Classes
      Scanner
30.  def doubleVal(negated: Boolean): Double

    Convert current strVal, base to double value.

    Convert current strVal, base to double value.

    Definition Classes
      Scanner
31.  def emitIdentifierDeprecationWarnings: Boolean

    Determines whether this scanner should emit identifier deprecation warnings, e.g.

    Determines whether this scanner should emit identifier deprecation warnings, e.g. when seeing `macro` or `then`, which are planned to become keywords in future versions of Scala.

    Definition Classes
      ParensAnalyzer → Scanner
32.  def ensuring(cond: (ParensAnalyzer) ⇒ Boolean, msg: ⇒ Any): ParensAnalyzer
    Implicit
      This member is added by an implicit conversion from ParensAnalyzer to Ensuring[ParensAnalyzer] performed by method Ensuring in scala.Predef.
    Definition Classes
      Ensuring
33.  def ensuring(cond: (ParensAnalyzer) ⇒ Boolean): ParensAnalyzer
    Implicit
      This member is added by an implicit conversion from ParensAnalyzer to Ensuring[ParensAnalyzer] performed by method Ensuring in scala.Predef.
    Definition Classes
      Ensuring
34.  def ensuring(cond: Boolean, msg: ⇒ Any): ParensAnalyzer
    Implicit
      This member is added by an implicit conversion from ParensAnalyzer to Ensuring[ParensAnalyzer] performed by method Ensuring in scala.Predef.
    Definition Classes
      Ensuring
35.  def ensuring(cond: Boolean): ParensAnalyzer
    Implicit
      This member is added by an implicit conversion from ParensAnalyzer to Ensuring[ParensAnalyzer] performed by method Ensuring in scala.Predef.
    Definition Classes
      Ensuring
36.  final def eq(arg0: AnyRef): Boolean
    Definition Classes
      AnyRef
37.  def equals(arg0: Any): Boolean
    Definition Classes
      AnyRef → Any
38.  def error(offset: Scanners.Offset, msg: String): Unit

    An error routine to call on bad unicode escapes \\uxxxx.

    An error routine to call on bad unicode escapes \\uxxxx.

    Definition Classes
      ParensAnalyzer → UnitScanner → SourceFileScanner → ScannerCommon → CharArrayReader
39.  final def fetchToken(): Unit

    read next token, filling TokenData fields of Scanner.

    read next token, filling TokenData fields of Scanner.

    Attributes
      protected
    Definition Classes
      Scanner
40.  def finalize(): Unit
    Attributes
      protected[lang]
    Definition Classes
      AnyRef
    Annotations
      @throws( classOf[java.lang.Throwable] )
41.  def finishDocComment(): Unit
    Attributes
      protected
    Definition Classes
      DocScanner
42.  def floatVal: Float
    Definition Classes
      Scanner
43.  def floatVal(negated: Boolean): Float

    Convert current strVal, base to float value.

    Convert current strVal, base to float value.

    Definition Classes
      Scanner
44.  def flushDoc(): Global.DocComment
    Definition Classes
      DocScanner
45.  def formatted(fmtstr: String): String
    Implicit
      This member is added by an implicit conversion from ParensAnalyzer to StringFormat[ParensAnalyzer] performed by method StringFormat in scala.Predef.
    Definition Classes
      StringFormat
    Annotations
      @inline()
46.  final def getClass(): Class[_]
    Definition Classes
      AnyRef → Any
    Annotations
      @native()
47.  def getFraction(): Unit

    read fractional part and exponent of floating point number if one is present.

    read fractional part and exponent of floating point number if one is present.

    Attributes
      protected
    Definition Classes
      Scanner
48.  def getLitChar(): Unit

    copy current character into cbuf, interpreting any escape sequences, and advance to next character.

    copy current character into cbuf, interpreting any escape sequences, and advance to next character.

    Attributes
      protected
    Definition Classes
      Scanner
49.  def getNumber(): Unit

    Read a number into strVal.

    Read a number into strVal.

    The `base` can be 8, 10 or 16, where base 8 flags a leading zero. For ints, base 8 is legal only for the case of exactly one zero.

    Attributes
      protected
    Definition Classes
      Scanner
50.  def hashCode(): Int
    Definition Classes
      AnyRef → Any
    Annotations
      @native()
51.  def healBraces(): List[BracePatch]

    overridden in UnitScanners

    overridden in UnitScanners

    Definition Classes
      UnitScanner → Scanner
52.  def inFirstOfStat(token: Scanners.Token): Boolean

    Can token start a statement?

    Can token start a statement?

    Definition Classes
      Scanner
53.  def inLastOfStat(token: Scanners.Token): Boolean

    Can token end a statement?

    Can token end a statement?

    Definition Classes
      Scanner
54.  def incompleteInputError(off: Scanners.Offset, msg: String): Unit
    Definition Classes
      UnitScanner → SourceFileScanner → ScannerCommon
55.  def incompleteInputError(msg: String): Unit

    signal an error where the input ended in the middle of a token

    signal an error where the input ended in the middle of a token

    Definition Classes
      Scanner
56.  def init(): Unit

    Initialization method: read first char, then first token

    Initialization method: read first char, then first token

    Definition Classes
      Scanner
57.  def insertPatch(patches: List[BracePatch], patch: BracePatch): List[BracePatch]
58.  def insertRBrace(): List[BracePatch]
59.  def intVal: Long
    Definition Classes
      Scanner
60.  def intVal(negated: Boolean): Long

    Convert current strVal, base to long value.

    Convert current strVal, base to long value. This is tricky because of max negative value.

    Conversions in base 10 and 16 are supported. As a permanent migration path, attempts to write base 8 literals except `0` emit a verbose error.

    Definition Classes
      Scanner
61.  def invalidEscape(): Unit
    Attributes
      protected
    Definition Classes
      Scanner
62.  def isAtEnd: Boolean
    Definition Classes
      Scanner
63.  final def isInstanceOf[T0]: Boolean
    Definition Classes
      Any
64.  def isUnicodeEscape: Boolean

    Is last character a unicode escape \\uxxxx?

    Is last character a unicode escape \\uxxxx?

    Definition Classes
      CharArrayReader
65.  val lastLineStartOffset: Int

    The start offset of the line before the current one

    The start offset of the line before the current one

    Definition Classes
      CharArrayReaderData
66.  val lastOffset: Scanners.Offset

    the offset of the character following the token preceding this one

    the offset of the character following the token preceding this one

    Definition Classes
      TokenData
67.  val lastUnicodeOffset: Int
    Attributes
      protected
    Definition Classes
      CharArrayReaderData
68.  def line(offset: Scanners.Offset): Int
69.  val lineStart: ArrayBuffer[Int]

    The offset of the first token on this line, or next following line if blank

70.  val lineStartOffset: Int

    The start offset of the current line

    The start offset of the current line

    Definition Classes
      CharArrayReaderData
71.  def lookaheadReader: CharArrayLookaheadReader

    A new reader that takes off at the current character position

    A new reader that takes off at the current character position

    Definition Classes
      CharArrayReader
72.  val name: Global.TermName

    the name of an identifier

    the name of an identifier

    Definition Classes
      TokenData → CommonTokenData
73.  final def ne(arg0: AnyRef): Boolean
    Definition Classes
      AnyRef
74.  val next: TokenData

    we need one token lookahead and one token history

    we need one token lookahead and one token history

    Definition Classes
      ScannerData
75.  final def nextChar(): Unit

    Advance one character; reducing CR;LF pairs to just LF

    Advance one character; reducing CR;LF pairs to just LF

    Definition Classes
      CharArrayReader
76.  final def nextRawChar(): Unit

    Advance one character, leaving CR;LF pairs intact.

    Advance one character, leaving CR;LF pairs intact. This is for use in multi-line strings, so there are no "potential line ends" here.

    Definition Classes
      CharArrayReader
77.  def nextToken(): Unit

    Produce next token, filling TokenData fields of Scanner.

    Produce next token, filling TokenData fields of Scanner.

    Definition Classes
      Scanner → ScannerCommon
78.  def nextTokenAllow(name: Global.Name): Unit

    Get next token, and allow the otherwise deprecated ident `name`

    Get next token, and allow the otherwise deprecated ident `name`

    Definition Classes
      Scanner
79.  final def notify(): Unit
    Definition Classes
      AnyRef
    Annotations
      @native()
80.  final def notifyAll(): Unit
    Definition Classes
      AnyRef
    Annotations
      @native()
81.  val offset: Scanners.Offset

    the offset of the first character of the current token

    the offset of the first character of the current token

    Definition Classes
      TokenData
82.  def parenBalance(token: Scanners.Token): Int

    overridden in UnitScanners

    overridden in UnitScanners

    Definition Classes
      UnitScanner → Scanner
83.  lazy val parensAnalyzer: ParensAnalyzer
    Definition Classes
      UnitScanner
84.  val prev: TokenData
    Definition Classes
      ScannerData
85.  def processCommentChar(): Unit
    Attributes
      protected
    Definition Classes
      DocScanner
86.  def putChar(c: Char): Unit

    append Unicode character to "cbuf" buffer

    append Unicode character to "cbuf" buffer

    Attributes
      protected
    Definition Classes
      Scanner
87.  final def putCommentChar(): Unit
    Attributes
      protected
    Definition Classes
      Scanner
88.  def registerDocComment(raw: String, pos: Global.Position): Unit
    Definition Classes
      DocScanner
89.  def resume(lastCode: Scanners.Token): Unit
    Definition Classes
      Scanner
90.  var sepRegions: List[Scanners.Token]

    a stack of tokens which indicates whether line-ends can be statement separators also used for keeping track of nesting levels.

    a stack of tokens which indicates whether line-ends can be statement separators also used for keeping track of nesting levels. We keep track of the closing symbol of a region. This can be RPAREN if region starts with '(' RBRACKET if region starts with '[' RBRACE if region starts with '{' ARROW if region starts with 'case' STRINGLIT if region is a string interpolation expression starting with '${' (the STRINGLIT appears twice in succession on the stack iff the expression is a multiline string literal).

    Definition Classes
      Scanner
91.  final def skipComment(): Boolean

    Definition Classes
      Scanner
92.  final def skipNestedComments(): Unit
    Definition Classes
      Scanner
    Annotations
      @tailrec()
93.  def skipToken(): Scanners.Offset

    read next token and return last offset

    read next token and return last offset

    Definition Classes
      Scanner
94.  val source: SourceFile
    Definition Classes
      SourceFileScanner
95.  val strVal: String

    the string value of a literal

    the string value of a literal

    Definition Classes
      TokenData
96.  final def synchronized[T0](arg0: ⇒ T0): T0
    Definition Classes
      AnyRef
97.  def syntaxError(msg: String): Unit

    generate an error at the current token offset

    generate an error at the current token offset

    Definition Classes
      Scanner
98.  def syntaxError(off: Scanners.Offset, msg: String): Unit

    generate an error at the given offset

    generate an error at the given offset

    Definition Classes
      Scanner
99.  var tabSeen: Boolean
100.  def toString(): String
     Definition Classes
       Scanner → AnyRef → Any
101.  val token: Scanners.Token

     the next token

     the next token

     Definition Classes
       TokenData → CommonTokenData
102.  val unit: Global.CompilationUnit
     Definition Classes
       UnitScanner
103.  final def wait(): Unit
     Definition Classes
       AnyRef
     Annotations
       @throws( ... )
104.  final def wait(arg0: Long, arg1: Int): Unit
     Definition Classes
       AnyRef
     Annotations
       @throws( ... )
105.  final def wait(arg0: Long): Unit
     Definition Classes
       AnyRef
     Annotations
       @throws( ... ) @native()
106.  def warning(off: Scanners.Offset, msg: String, category: WarningCategory): Unit
     Definition Classes
       UnitScanner → SourceFileScanner → ScannerCommon
107.  def →[B](y: B): (ParensAnalyzer, B)
     Implicit
       This member is added by an implicit conversion from ParensAnalyzer to ArrowAssoc[ParensAnalyzer] performed by method ArrowAssoc in scala.Predef.
     Definition Classes
       ArrowAssoc

### Inherited from UnitScanner

### Inherited from SourceFileScanner

### Inherited from Scanner

### Inherited from Scanners.DocScanner

### Inherited from Scanners.ScannerCommon

### Inherited from ScannerData

### Inherited from TokenData

### Inherited from Scanners.CommonTokenData

### Inherited from CharArrayReader

### Inherited from CharArrayReaderData

### Inherited from AnyRef

### Inherited from Any

### Inherited by implicit conversion any2stringadd from ParensAnalyzer to any2stringadd[ParensAnalyzer]

### Inherited by implicit conversion StringFormat from ParensAnalyzer to StringFormat[ParensAnalyzer]

### Inherited by implicit conversion Ensuring from ParensAnalyzer to Ensuring[ParensAnalyzer]

### Inherited by implicit conversion ArrowAssoc from ParensAnalyzer to ArrowAssoc[ParensAnalyzer]

### Ungrouped